#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import <UIKit/UITextView.h>

#define KUJI_MAX 6

//////////////////////////////////////////////////////////////////////////////
// interface  definition
//////////////////////////////////////////////////////////////////////////////

@interface OmikujiApplication : UIApplication
{
  UIImageView *pictView;
  UITextView *textView;
  NSTimer *timer;
  int ax;
  int ay;
  int az;
  int tic;
  int state;
  int count;
  int kuji;
}
- (void) interval_function;
- (void) applicationDidFinishLaunching: (id) unused;
@end


//////////////////////////////////////////////////////////////////////////////
//  implementation
//////////////////////////////////////////////////////////////////////////////

@implementation OmikujiApplication
- (void)acceleratedInX:(float)xx Y:(float)yy Z:(float)zz { ax = xx*2500; ay = yy*2500; az = zz*2500; }

- (void) interval_function
{
  tic++;
  if (state==0) {
	srand(time(0));
	[textView setText: @"Ready."];
	[pictView setImage: [UIImage imageNamed:@"ready.png"]];
	state=1;
	return;
  }
  if (state==1) {
	if ( (ax < 200) && (ax > -200) ) {  //  stable?
		[pictView setImage: [UIImage imageNamed:@"shake.png"]];
		[textView setText: @"Shake."];
		state=2;
		count=0;
	}
	return;
  }
  if (state==2) {
	if ( (ax > 1200)||(ax < -1200) ) { // shake?
		NSString *msg = [NSString stringWithFormat:@"! Shake. (%i,%i,%i)", ax,ay,az];
		[textView setText: msg];
		kuji = rand() % KUJI_MAX;
		count++;
	} else {
		NSString *msg = [NSString stringWithFormat:@"Shake. (%i,%i,%i)", ax,ay,az];
		[textView setText: msg];
	}
	if ( ( count >= 2 ) || ( ( count ==1 )&&( tic > 10 ) ) )  {
		[textView setText: @"Draw lots."];
		[pictView setImage: [UIImage imageNamed:@"draw.png"]];
		state=3;
	}
	return;
  }
  if (state==3) {
	if ( (ay > 750) && (ax < 200 ) && (ax > -200 ) && (az < 0) && (az > -750) ) {
		[pictView setImage: [UIImage imageNamed:@"draw2.png"]];
		[textView setText: @"drawing..."];
		state=4;
		count=0;
	} else {
		NSString *msg = [NSString stringWithFormat:@"Draw. (%i,%i,%i)", ax,ay,az];
		[textView setText: msg];
	}
	return;
  }
  if (state==4) {
	count++;
	if (count>=5) { state=5; }
	return;
  }
  if (state==5) {
	//show result
	NSString *msg = [NSString stringWithFormat:@"result %i", kuji];
	[textView setText: msg];
	NSString *pngfile = [NSString stringWithFormat:@"kuji%i.png", kuji];
	[pictView setImage: [UIImage imageNamed: pngfile]];
	state=6;
	return;
  }
  if (state==6) {
	// the end
  }
}

- (void) applicationDidFinishLaunching: (id) unused
{
  CGRect rect = [UIHardware fullScreenApplicationContentRect];
  rect.origin.x = rect.origin.y = 0;
  UIWindow *window = [[UIWindow alloc] initWithContentRect:rect];
  [window orderFront: self];
  [window makeKey: self];
  [window _setHidden: NO];
  UIView *mainView = [[UIView alloc] initWithFrame: rect];
  textView = [[UITextView alloc]  initWithFrame: CGRectMake(0, 480-60, 320, 60) ];
  [textView setEditable:NO];
  [textView setDelegate: self];
  pictView = [[UIImageView alloc] initWithFrame: rect];
  [mainView addSubview: pictView];
  [mainView addSubview: textView];
  [window setContentView:mainView];
  [window setNeedsDisplay];
  [pictView setImage: [UIImage imageNamed:@"Default.png"]];
  timer = [NSTimer scheduledTimerWithTimeInterval:.5 target:self selector:@selector(interval_function) userInfo:nil repeats:YES];
  tic=0;
  state=0;
}
@end


//////////////////////////////////////////////////////////////////////////////
//  start
//////////////////////////////////////////////////////////////////////////////
int main(int argc, char **argv)
{
  NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
  return UIApplicationMain(argc, argv, [OmikujiApplication class]);
}


